<template>
    <a-modal :open="modal.open" :title="modal.title" :width="640" :confirm-loading="modal.confirmLoading"
        :after-close="onAfterClose" :cancel-text="cancelText" :ok-text="okText" @ok="handleOk" @cancel="handleCancel">
        <a-spin :spinning="spining">
            <a-form ref="formRef" :model="formData" :rules="formRules">
                <a-card class="mb-8-2">
                    <a-row :gutter="12">
                        <a-col :span="12">
                            <a-form-item :label="'客户名称'" name="name">
                                <a-input :placeholder="'请输入客户名称'" v-model:value="formData.name"></a-input>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'联系电话'" name="phone">
                                <a-input :placeholder="'请输入联系电话'" v-model:value="formData.phone"></a-input>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'出生日期'" name="birthday">
                                <a-date-picker v-model:value="formData.birthday" style="width: 100%;" />
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'所属区域'" name="areaId">
                                <a-select ref="select" v-model:value="formData.areaId">
                                    <a-select-option v-for="item in areaEnum.getAll()" :value="item.value">{{
                                        item.name }}</a-select-option>
                                </a-select>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'客户等级'" name="grade">
                                <a-select ref="select" v-model:value="formData.grade">
                                    <a-select-option v-for="item in 8" :value="item">{{ item + '级' }}</a-select-option>
                                </a-select>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'当前积分'" name="currentbalance">
                                <a-input-number :placeholder="'请输入当前积分'" v-model:value="formData.currentbalance"
                                    style="width: 100%;"></a-input-number>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'历史积分'" name="balance">
                                <a-input-number :placeholder="'请输入历史积分'" v-model:value="formData.balance"
                                    style="width: 100%;"></a-input-number>
                            </a-form-item>
                        </a-col>

                        <a-col :span="12">
                            <a-form-item :label="'客户类型'" name="type">
                                <a-select ref="select" v-model:value="formData.type">
                                    <a-select-option v-for="item in customersEnum.getAll()" :value="item.value">{{
                                        item.name }}</a-select-option>
                                </a-select>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'状态'" name="status">
                                <a-radio-group v-model:value="formData.status" :options="[
                                    { label: '启用', value: 'enabled' },
                                    { label: '停用', value: 'disabled' },
                                ]"></a-radio-group>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'头像'" name="fileList">
                                <gx-upload v-model="formData.fileList" accept-types=".jpg,.png,.webp" :fileNumber="1"
                                    @uploadSuccess="uploadSuccess" />
                            </a-form-item>
                        </a-col>
                    </a-row>
                </a-card>
            </a-form>
        </a-spin>
    </a-modal>
</template>

<script setup>
import { cloneDeep } from 'lodash-es'
import { ref, onBeforeMount } from 'vue'
import { config } from '@/config'
import apis from '@/apis'
import { useForm, useModal, useSpining } from '@/hooks'
import { message } from 'ant-design-vue'
import { useI18n } from 'vue-i18n'
import dayjs from 'dayjs'
import GxUpload from '@/components/GxUpload/index.vue'
import { customersEnum, areaEnum } from "@/enums/useEnum"
const emit = defineEmits(['ok'])
const { t } = useI18n() // 解构出t方法
const { modal, showModal, hideModal, showLoading, hideLoading } = useModal()
const { formRecord, formData, formRef, formRules, resetForm } = useForm()
const { spining, showSpining, hideSpining } = useSpining()
const cancelText = ref(t('button.cancel'))
const okText = ref(t('button.confirm'))
const fileList = ref([])
formRules.value = {
    name: [{ required: true, message: '请输入客户名称' }],
    status: [{ required: true, message: '请选择状态', trigger: 'change' }],
    areaId: [{ required: true, message: '请选择所属区域', trigger: 'change' }],
    type: [{ required: true, message: '请选择客户类型', trigger: 'change' }]
}

onBeforeMount(() => {
    formData.value.areaId = 1
})

/**
 * 新建
 */
function handleCreate() {
    showModal({
        type: 'create',
        title: '新增客户',
    })
    // initData()
    formData.value.status = 'enabled'
}

/**
 * 编辑
 */
async function handleEdit(record = {}) {
    showModal({
        type: 'edit',
        title: '编辑客户',
    })
    try {
        showSpining()
        const { data, success } = await apis.customer.getItem(record.id).catch()
        if (!success) {
            hideModal()
            return
        }
        hideSpining()
        formData.value = { ...data }
        formData.value.birthday = dayjs(data.birthday)
        if (data.avatar) {
            formData.value.fileList = [config('http.apiBasic') + data.avatar]
        }
    } catch (error) {
        message.error({ content: error.message })
        hideSpining()
    }

}
const uploadSuccess = (data) => {
    fileList.value.push(data)
}
/**
 * 确定
 */
function handleOk() {
    formRef.value.validateFields().then(async (values) => {
        try {
            showLoading()
            const params = {
                ...values,
                avatar: fileList.value[0]
            }
            let result = null
            switch (modal.value.type) {
                case 'create':
                    result = await apis.customer.createProject(params).catch((error) => {
                        throw new Error(error)
                    })
                    break
                case 'edit':
                    result = await apis.customer.updateItem(formData.value.id, params).catch(() => {
                        throw new Error(error)
                    })
                    break
            }
            hideLoading()
            if (config('http.code.success') === result?.success) {
                hideModal()
                emit('ok')
            }
        } catch (error) {
            message.error({ content: error.message })
            hideLoading()
        }
    })
        .catch((e) => {
            hideLoading()
        })
}


/**
 * 取消
 */
function handleCancel() {
    formData.value.areaId = 1
    hideModal()
}

/**
 * 关闭后
 */
function onAfterClose() {
    resetForm()
    hideLoading()
}

defineExpose({
    handleCreate,
    handleEdit,
})
</script>

<style lang="less" scoped></style>
